CREATE OR REPLACE FUNCTION RETORNA_SALDO_CTB(
  P_CDFILIAL    IN VARCHAR2,
  P_NRLANCTONF  IN VARCHAR2,
  P_CDCONTCOME  IN VARCHAR2,
  P_VRPROV      IN FLOAT,
  P_IDVALOR     IN VARCHAR2)
  RETURN FLOAT IS

V_VALOR        FLOAT := 0;
V_DIF          FLOAT := 0;
V_CONTCTBL     VARCHAR2(20);
V_NRLANCCONT   VARCHAR2(12);
V_CDEMPRESA    VARCHAR2(02);
V_IDENTRSAIDOP VARCHAR2(01);
V_NRNOTAFISC   VARCHAR2(20);

BEGIN
  /*DADOS DA PROVISO DA NOTA FISCAL*/
  SELECT CDEMPRESA,   NRLANCTBDOC, IDENTRSAIDOP, NRNOTAFISC
    INTO V_CDEMPRESA, V_NRLANCCONT, V_IDENTRSAIDOP, V_NRNOTAFISC
    FROM NOTAFISCAL NF
   WHERE NF.CDFILIAL   = P_CDFILIAL
     AND NF.NRLANCTONF = P_NRLANCTONF;
   /*DADOS DA BAIXA PAGAMENTO*/
   FOR C_BX_P IN (SELECT BX.NRLCTBBPAG
                    FROM BOLETPAGAR BO, BAIXAPAGA BX, (SELECT DISTINCT CP.CDFILIBPAG, CP.NRLANBOLPAG
                                                         FROM NOTAFISCAL NF, CONTAPAGAR CP
                                                        WHERE NF.CDFILIAL     = P_CDFILIAL
                                                          AND NF.NRLANCTONF   = P_NRLANCTONF
                                                          AND CP.CDFILIAL     = NF.CDFILIAL
                                                          AND CP.NRLANCTONF   = NF.NRLANCTONF
                                                          AND NF.CDFORNECED   = P_CDCONTCOME
                                                          AND NF.IDENTRSAIDOP = V_IDENTRSAIDOP) CP
                   WHERE BO.CDFILIAL = CP.CDFILIBPAG
                     AND BO.NRLANBOLPAG = CP.NRLANBOLPAG
                     AND BO.CDFILIBAIPAG = BX.CDFILIAL
                     AND BO.NRBAIXAPAG = BX.NRBAIXAPAG) LOOP
      /*VERIFICA A PARTIDA DO LANAMENTO CONTBIL PELO CODIGO COMERCIAL E NUMERO DO DOCUMENTO NO HISTRICO*/
      FOR C_LB IN (SELECT VRLANCAMENT
                     FROM LANCCONT
                    WHERE CDEMPRESA  = V_CDEMPRESA
                      AND NRLANCCONT = C_BX_P.NRLCTBBPAG
                      AND CDCONTCOME = P_CDCONTCOME
                      AND DSHISTLANC LIKE '%'||V_NRNOTAFISC||'%' ) LOOP
          V_VALOR := V_VALOR + ABS(C_LB.VRLANCAMENT);


      END LOOP;
   END LOOP;
   /*DADOS DA PROVISO RECEBIMENTO*/
   FOR C_BX_REC IN (SELECT BX.NRLCTBBREC
                      FROM BOLETRECEBER BO, BAIXARECEBIDA BX, (SELECT DISTINCT CP.CDFILIBOLREC, CP.NRLANBOLREC
                                                                 FROM NOTAFISCAL NF, CONTARECEBER CP
                                                                WHERE NF.CDFILIAL     = P_CDFILIAL
                                                                  AND NF.NRLANCTONF   = P_NRLANCTONF
                                                                  AND CP.CDFILIAL     = NF.CDFILIAL
                                                                  AND CP.NRLANCTONF   = NF.NRLANCTONF
                                                                  AND NF.CDCLIENTE    = P_CDCONTCOME
                                                                  AND NF.IDENTRSAIDOP = V_IDENTRSAIDOP) CP
                     WHERE BO.CDFILIAL     = CP.CDFILIBOLREC
                       AND BO.NRLANBOLREC  = CP.NRLANBOLREC
                       AND BO.CDFILIBAIREC = BX.CDFILIAL
                       AND BO.NRBAIXAREC   = BX.NRBAIXAREC) LOOP
      /*VERIFICA A PARTIDA DO LANAMENTO CONTBIL PELO CODIGO COMERCIAL E NUMERO DO DOCUMENTO NO HISTRICO*/
      FOR C_LB IN (SELECT VRLANCAMENT
                     FROM LANCCONT
                    WHERE CDEMPRESA  = V_CDEMPRESA
                      AND NRLANCCONT = C_BX_REC.NRLCTBBREC
                      AND CDCONTCOME = P_CDCONTCOME
                      AND DSHISTLANC LIKE '%'||V_NRNOTAFISC||'%' ) LOOP
          V_VALOR := V_VALOR + ABS(C_LB.VRLANCAMENT);


      END LOOP;



   END LOOP;
   /*RETORNA O VALOR DO SALDO CONTBIL OU A DIFERENA RESTANTE*/
   IF P_IDVALOR = 'D' THEN
      V_DIF := P_VRPROV - V_VALOR;
      RETURN V_DIF;
   ELSE
      RETURN V_VALOR;
   END IF;
END;
/